using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Data.Sqlite;

// For more information on enabling MVC for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860

namespace KundewebLogin.Controllers
{
    public class AdminController : Controller
    {
        // GET: /<controller>/

        public IActionResult Kundeliste()
        {
            return View();
        }
        public IActionResult Poststeder()
        {
            return View();
        }

        public IActionResult NyPostkat()
        {
            return View();
        }

        [HttpPost]
        public IActionResult NyPostkat(string inpPostnr, string inpSted)
        {
            using (SqliteConnection con = new SqliteConnection(Startup.ConStr))
            {
                con.Open();
                string strSQL = "INSERT INTO Postkat (Postnr,Sted) VALUES(@Postnr,@Sted)";
                using (SqliteCommand com = new SqliteCommand(strSQL, con))
                {
                    com.Parameters.Add(new SqliteParameter("@Postnr", inpPostnr));
                    com.Parameters.Add(new SqliteParameter("@Sted", inpSted));
                    com.ExecuteNonQuery();
                }
            }
            Response.Redirect("/Admin/Poststeder");
            return View();
        }
        public IActionResult EndrePostkat(string Postnr)
        {
            using (SqliteConnection con = new SqliteConnection(Startup.ConStr))
            {
                con.Open();
                string strSQL = "SELECT Postnr, Sted FROM Postkat WHERE Postnr=" + Postnr;
                using (SqliteCommand com = new SqliteCommand(strSQL, con))
                {
                    using (SqliteDataReader dr = com.ExecuteReader())
                    {
                        while (dr.Read())
                        {
                            ViewBag.Postnr = dr["Postnr"];
                            ViewBag.Sted = dr["Sted"];
                        }
                    }
                }
            }
            return View();
        }

        [HttpPost]
        public IActionResult EndrePostkat(string inpPostnr,string inpSted)
        {
            using (SqliteConnection con = new SqliteConnection(Startup.ConStr))
            {
                con.Open();
                string strSQL = "UPDATE Postkat SET Sted=@Sted WHERE Postnr=@Postnr";
                using (SqliteCommand com = new SqliteCommand(strSQL, con))
                {
                    com.Parameters.Add(new SqliteParameter("@Postnr", inpPostnr));
                    com.Parameters.Add(new SqliteParameter("@Sted", inpSted));
                    com.ExecuteNonQuery();
                }
            }
            Response.Redirect("/Admin/Poststeder");
            return View();
        }
        public IActionResult SlettePostkat(string Postnr)
        {
            try
            {
                using (SqliteConnection con = new SqliteConnection(Startup.ConStr))
                {
                    con.Open();
                    string strSQL = "Delete FROM Postkat WHERE Postnr=@Postnr";
                    using (SqliteCommand com = new SqliteCommand(strSQL, con))
                    {
                        com.Parameters.Add(new SqliteParameter("@Postnr", Postnr));
                        com.ExecuteNonQuery();
                    }
                }
                ViewBag.Melding = "Posten for postnr " + Postnr + " er nå slettet";
            }
            
        
            catch (Exception ex)
            {
                ViewBag.Melding = ex.Message;
            }
                    
            return View();
        }

        public IActionResult Kunder()
        {
            return View();
        }

        public IActionResult NyKunde()
        {

            return View();
        }

        [HttpPost]
        public IActionResult NyKunde(string inpEtternavn, string inpFornavn, string inpAdresse, string selPostnr, string inpTelefon, string inpSaldo)
        {
            try
            {
                using (SqliteConnection con = new SqliteConnection(Startup.ConStr))
                {
                    con.Open();
                    string strSQL = "INSERT INTO Kunde (Etternavn,Fornavn, Adresse, Postnr, Telefon, Saldo) VALUES(@Etternavn,@Fornavn, @Adresse, @Postnr, @Telefon, @Saldo)";
                    using (SqliteCommand com = new SqliteCommand(strSQL, con))
                    {
                        com.Parameters.Add(new SqliteParameter("@Etternavn", inpEtternavn));
                        com.Parameters.Add(new SqliteParameter("@Fornavn", inpFornavn));
                        com.Parameters.Add(new SqliteParameter("@Adresse", inpAdresse));
                        com.Parameters.Add(new SqliteParameter("@Postnr", selPostnr));
                        com.Parameters.Add(new SqliteParameter("@Telefon", inpTelefon == null ? "" : inpTelefon));
                        com.Parameters.Add(new SqliteParameter("@Saldo", inpSaldo));

                        com.ExecuteNonQuery();
                    }
                }
                Response.Redirect("/Admin/Kunder");

            }
            catch (Exception ex)
            {
                ViewBag.Feil = ex.Message;
            }
            return View();
        }

        public IActionResult EndreKunde(string KundeID)
        {
            using (SqliteConnection con = new SqliteConnection(Startup.ConStr))
            {
                con.Open();
                string strSQL = "SELECT * FROM Kunde WHERE KundeID=" + KundeID;
                using (SqliteCommand com = new SqliteCommand(strSQL, con))
                {
                    using (SqliteDataReader dr = com.ExecuteReader())
                    {
                        while (dr.Read())
                        {
                            ViewBag.KundeID = dr["KundeID"];
                            ViewBag.Etternavn = dr["Etternavn"];
                            ViewBag.Fornavn = dr["Fornavn"];
                            ViewBag.Adresse = dr["Adresse"];
                            ViewBag.Postnr = dr["Postnr"];
                            ViewBag.Telefon = dr["Telefon"];
                            ViewBag.Saldo = dr["Saldo"];
                        }
                    }
                }
            }
            return View();
        }
        [HttpPost]
        public IActionResult EndreKunde(string inpKundeID, string inpEtternavn, string inpFornavn,string inpAdresse, string selPostnr, string inpTelefon, string inpSaldo)
        {
            using (SqliteConnection con = new SqliteConnection(Startup.ConStr))
            {
                con.Open();
                string strSQL = "UPDATE Kunde SET Etternavn=@Etternavn, Fornavn=@Fornavn, Adresse=@Adresse, Postnr=@Postnr, Telefon=@Telefon, Saldo=@Saldo WHERE KundeID=@KundeID";
                using (SqliteCommand com = new SqliteCommand(strSQL, con))
                {
                    com.Parameters.Add(new SqliteParameter("@KundeID", int.Parse(inpKundeID)));
                    com.Parameters.Add(new SqliteParameter("@Etternavn", inpEtternavn));
                    com.Parameters.Add(new SqliteParameter("@Fornavn", inpFornavn));
                    com.Parameters.Add(new SqliteParameter("@Adresse", inpAdresse));
                    com.Parameters.Add(new SqliteParameter("@Postnr", selPostnr));
                    com.Parameters.Add(new SqliteParameter("@Telefon", inpTelefon == null ? "" : inpTelefon));
                    com.Parameters.Add(new SqliteParameter("@Saldo", float.Parse(inpSaldo)));
                    com.ExecuteNonQuery();
                }
            }
            Response.Redirect("/Admin/Kunder");
            return View();
        }

        public IActionResult SletteKunde(string KundeID)
        {
            try
            {
                using (SqliteConnection con = new SqliteConnection(Startup.ConStr))
                {
                    con.Open();
                    string strSQL = "Delete FROM Kunde WHERE KundeID=@KundeID";
                    using (SqliteCommand com = new SqliteCommand(strSQL, con))
                    {
                        com.Parameters.Add(new SqliteParameter("@KundeID", KundeID));
                        com.ExecuteNonQuery();
                    }
                }
                ViewBag.Melding = "Posten for KundeID " + KundeID + " er nå slettet";
            }
        
        
        catch (Exception ex)
        {
            ViewBag.Melding = ex.Message;
        }
        return View();
        }

        public IActionResult Kundeutvalg()
        {
            ViewBag.Postnr = "0000";  
            return View();
        }
        [HttpPost]
        public IActionResult Kundeutvalg(string selSted)
        {
            ViewBag.Postnr = selSted;
            return View();
        }

        public IActionResult Saldo()
        {
            return View();
        }

        [HttpPost]
        public IActionResult Saldo(string selKunde, string inpPros)
        {
            using (SqliteConnection con = new SqliteConnection(Startup.ConStr))
            {
            con.Open();
            string strSQL = "UPDATE Kunde SET Saldo=Saldo * (100 + @Saldo) / 100 WHERE KundeID=@KundeID";
            using (SqliteCommand com = new SqliteCommand(strSQL, con))
            {
                com.Parameters.Add(new SqliteParameter("@KundeID", selKunde));
                com.Parameters.Add(new SqliteParameter("@Saldo", inpPros));
                com.ExecuteNonQuery();
            }
            }
            return View();
        }

    }
}
